package com.nokia.tsl_data.properties;

import org.springframework.boot.context.properties.ConfigurationProperties;

import lombok.Data;

@Data
@ConfigurationProperties(prefix = "tsl.data")
public class TslDataProperties {
    /**
     * 输出
     */
    private String outputPath = "./output";
    private String outputFileNamePrefix = "投诉清单各地市投诉率";

    /**
     * 目标值
     */
    // 满意度目标
    private double satisfiedCompliance = 0.92d;
    // 解决率目标
    private double resolutionCompliance = 0.85d;
    // 响应率目标
    private double responseCompliance = 0.99d;
    // 移网综合投诉评价 目标
    private double evaluation = 0.95d;
    // 处理时长达标值 单位是小时
    private int duration = 30;

    /**
     * 河北_CEM高品质2日详表
     */
    // HighQualityListDay 文件存储路径
    private String dirOfHighQualityListDay = "/data/nenglishangdian/high_quality_list_day";
    // HighQualityListDay 文件前缀
    private String prefixOfHighQualityListDay = "HE_D_HIGH_QUALITY_LIST_DAY_1114200095151828992_";
    // HighQualityListDay 字段数量
    private Integer filedNumOfHighQualityListDay = 70;

    /**
     * 河北_CEM高品质2日统计
     */
    // HighQualityCountDay 文件存储路径
    private String dirOfHighQualityCountDay = "/data/nenglishangdian/high_quality_count/";
    // HighQualityCountDay 文件前缀
    private String prefixOfHighQualityCountDay = "HE_D_HIGH_QUALITY_COUNT_DAY_1087387382887477248_";
    // HighQualityCountDay 字段数量
    private Integer filedNumOfHighQualityCountDay = 33;

    /**
     * 河北_CEM移网质量投诉明细
     */
    // HighQualityCountDay 文件存储路径
    private String dirOfMobileComplaint = "/data/nenglishangdian/mobile_complaint/";
    // HighQualityCountDay 文件前缀
    private String prefixOfMobileComplaint = "HE_D_MOBILE_COMPLAINT_DETAILS_DAY_1087468015013851136_";
    // HighQualityCountDay 字段数量
    private Integer filedNumOfMobileComplaintDay = 47;

    /**
     * 河北客户体验管理智能定责投诉明细月累计接口日
     */
    private String dirOfComplaintDetailsFixYwdDay = "/data/nenglishangdian/complaint_details_fix_ywd_day/";
    private String prefixOfComplaintDetailsFixYwdDay = "HE_D_COMPLAINT_DETAILS_FIX_YWD_DAY_1186327221372567552_";
    private Integer filedNumOfComplaintDetailsFixYwdDay = 95;

    /**
     * 河北客户体验管理系统移网网络体验明细日信息
     */
    // 20250312 更新 暂时不修改入库字段数量 有需要时再入库新增字段
    private String dirOfCemMobileExperienceList = "/data/nenglishangdian/HE_D_CEM_MOBILE_EXPERIENCE_LIST_NEW/";
    private String prefixOfCemMobileExperienceList = "HE_D_CEM_MOBILE_EXPERIENCE_LIST_1348973255222370304_";
    // private String dirOfCemMobileExperienceList =
    // "/data/nenglishangdian/HE_D_CEM_MOBILE_EXPERIENCE_LIST/";
    // private String prefixOfCemMobileExperienceList =
    // "HE_D_CEM_MOBILE_EXPERIENCE_LIST_1193846275255566336_";
    private Integer filedNumOfCemMobileExperienceList = 17;
}
